package poligoni;

public abstract class Poligono
{
	Lato[] lati;

	public Poligono(int numLati)
	{
		lati = new Lato[numLati];
		System.out.println("Ho costruito un poligono con " + numLati + " lati");
	}

	public Poligono()
	{
		this(3);
	}

	public void setLato(Lato lato, int pos) throws LatoDuplicatoException
	{
		if(lati[pos] != null)//non posso sostituire un lato gia' inserito
		{
			throw (new LatoDuplicatoException());
		}
		lati[pos] = lato;
	}

	public void setLato(int len, int pos) throws LatoDuplicatoException
	{
		this.setLato(new Lato(len), pos);
	}

	public double getLato(int pos)
	{
		return lati[pos].getLunghezza();
	}

	public double perimetro()
	{
		double retval = 0;
		int i = 0;
		for(i=0;i<lati.length;i++)
		{
			retval += lati[i].getLunghezza();
		}

		/* Questa versione non genera eccezioni ma gestisce in locale
		try
		{
			for(i=0;i<lati.length;i++)
			{
				retval += lati[i].getLunghezza();
			}
		}
		catch(NullPointerException npe)
		{
			System.err.println("Non tutti i lati del poligono sono inizializzati");
			return -1.0;
		}
		*/
		return retval;
	}

	public abstract double area();
}
