package poligoni;
import java.util.NoSuchElementException;

public class CircularObjectQueue
{
	Object[] storage;
	int head, tail, len;

	public CircularObjectQueue(int maxLen)
	{
		storage = new Object[maxLen];
		head = tail = len = 0;
	}

	private CircularObjectQueue()
	{
		throw new RuntimeException("Non e' possibile non definire la lunghezza massima");
	}

	public boolean add(Object e)
	{
		/*
		if(len == storage.length)
		{
			throw new IllegalStateException("Coda piena: " + len);
		}
		//se vogliamo rendere incompatibile l'elemento null
		if(e == null)
		{
			throw new NullPointerException();
		}

		storage[tail] = e;
		tail = (tail + 1)%storage.length;
		len++;

		return true;
		*/

		if(isFull())
		{
			throw new IllegalStateException("Coda piena: " + len);
		}
		return inserisci(e);
	}

	public boolean offer(Object e)
	{
		if(isFull())
		{
			return false;
		}
		return inserisci(e);
	}

	public boolean isFull()
	{
		return (len == storage.length);
	}

	private boolean inserisci(Object elem)
	{
		storage[tail] = elem;
		tail = (tail + 1)%storage.length;
		len++;

		return true;
	}

	public boolean isEmpty()
	{
		return len == 0;
	}

	private Object estraiTesta()
	{
		Object retval = storage[head];
		head = (head + 1)%storage.length;
		len--;
		return retval;
	}

	public Object remove()
	{
		if(isEmpty())
		{
			throw new java.util.NoSuchElementException("Coda vuota");
		}
		return estraiTesta();
	}

	/**
	* Metodo che estrae l'elemento di testa. In caso di coda vuota ritorna null. ATTENZIONE, l'implementazione corrente non impedisce l'inserimento di un elemento null.
	*/
	public Object poll()
	{
		if(isEmpty())
		{
			return null;
		}
		return estraiTesta();
	}

	public Object element()
	{
		if(isEmpty())
		{
			throw new NoSuchElementException("Coda vuota");
		}
		//return storage[head];
		return getHead();
	}

	public Object peek()
	{
		if(isEmpty())
		{
			return null;
		}
		//return storage[head];
		return getHead();
	}

	private Object getHead()
	{
		return storage[head];
	}

  public String toString()
  {
    String retval = "[";
    int i = 0;
		int k = 0;
    for(i=0,k=head;i<len;i++, k = (k+1)%storage.length)
    {
      //retval = retval.concat(storage[k].toString())+ ", ";
      retval = retval.concat(String.valueOf(storage[k])+ ", ");

			// Non funziona! Stringhe oggetti immutabili e niente side effects!
      //retval.concat(String.valueOf(storage[k])+ ", ");
    }
    retval = retval.concat("]");
    return retval;
  }
}
