package figure;

import java.io.*;

/**
* Classe che legge da un file una sequenza di oggetti Disegnabile e li visualizza sulla console.
*/
public class Disegnatore
{
	poligoni.CircularObjectQueue lista = new poligoni.CircularObjectQueue(20);

	public static void main(String[] argv)
	{
		File f = new File(argv[0]);
		Disegnatore d = new Disegnatore();
		// inserisco un oggetto non disegnabile per far vedere che il compilatore non se ne puo' accorgere
		d.lista.offer(argv[0]);
		try
		{
			d.caricaFigureDaFile(f);
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		System.out.println(d.lista);
		d.visualizzaFigure();
	}

	public int caricaFigureDaFile(File f) throws IOException
	{
		BufferedReader br = null;
		br = new BufferedReader(new FileReader(f));

		String tipo = null;
		while( (tipo = br.readLine()) != null)
		{
			Popolabile p = null;
			if(tipo.equals("Triangolo"))
			{
				p = new Triangolo();
			}
			else if(tipo.equals("Quadrato"))
			{
				p = new Quadrato();
			}
			else if(tipo.equals("Rettangolo"))
			{
				p = new Rettangolo();
			}
			else if(tipo.equals("TortaDiMele"))
			{
				p = new TortaDiMele();
			}
			else
			{
				System.err.println("Tipo <" + tipo + "> non noto al sistema");
				continue;
			}

			if(p.popola(br))
			{
				lista.add(p);
			}
		}
		return lista.size();
	}

	public int visualizzaFigure()
	{
		int retval = 0;
		int i = 0;
		for(i=0;i<lista.size();i++)
		{
			//Disegnabile disegnabile = (Disegnabile)lista.poll();
			Object tmp = lista.poll();
			if( !(tmp instanceof Disegnabile) )
			{
				System.out.println(String.valueOf(tmp) + " non e' Disegnabile");
			}
			else
			{
				((Disegnabile)tmp).disegnati();
				retval++;
			}
			lista.offer(tmp);
		}
		return retval;
	}
}
