package map;

import java.util.*;
import java.io.*;
import figure.Popolabile;

public class UsaMap
{
	Map<String, List<Libro>> autori = new HashMap<String, List<Libro>>();

	public static void main(String[] argv) throws IOException
	{
		(new UsaMap()).exec(argv);
	}

	public void exec(String[] argv) throws IOException
	{
		BufferedReader br = new BufferedReader(new FileReader(new File(argv[0])));

		String tipo = null;
		while( (tipo = br.readLine()) != null)
		{
			Popolabile p = null;
			if(tipo.equals("Libro"))
			{
				System.out.println("Nuovo Libro");
				p = new Libro();
			}
			else
			{
				System.err.println("Oggetto <" + tipo + "> non noto");
				continue;
			}
			if(p.popola(br))
			{
				if(p instanceof Libro)
				{
					Libro b = (Libro)p;
					if(b.validato)
					{
						List<Libro> l = autori.get(b.autore);
						if(l == null)
						{
							l = new LinkedList<Libro>();
							autori.put(b.autore, l);
						}
						l.add(b);
					}
					else
					{
						System.out.println("Libro non validato");
					}
				}
				else
				{
					System.out.println("Se non e' un Libro non so che fare");
				}
			}
			else
			{
				System.out.println("popola fallito");
			}
		}
		br.close();
		System.out.println(autori);
	}
}
