package interfacce;
public interface Stack
{
	/**
	* Metodo di test della condizione di stack vuoto. Ritorna true se e solo se lo stack e' vuoto.
	*/
	boolean empty();

	/**
	* Inserisce un elemento nello stack. Ritorna la dimensione dello stack dopo l'inserimento.
	*/
	int push(Object o);

	/**
	* Ritorna l'oggetto in cima allo stack senza rimuoverlo. E' un'operazione idempotente.
	*/
	Object peek();

	/**
	* Ritorna e rimuove l'oggetto in cima allo stack.
	*/
	Object pop();

	/**
	* Cerca l'elemento passato come parametro all'interno dello stack. Se lo trova ritorna la sua distanza dalla cima dello stack. E' un'operazione idempotente.
	*/
	int search(Object o);

	/**
	* Cerca l'elemento passato come parametro e lo rimuove dallo stack.
	* Ritorna l'elemento rimosso, null se l'elemento non c'e'.
	*/
	Object searchAndRemove(Object o);
}
