package tasks;

import java.util.*;
import java.io.*;

public class Schedulatore
{
	List<Task>[] tasks;
	List<Task> scaduti;
	BufferedReader stdin;

	public Schedulatore()
	{
		stdin = new BufferedReader(new InputStreamReader(System.in));
		tasks = (List<Task>[])(new LinkedList[10]);
		scaduti = new LinkedList<Task>();
		int i = 0;
		for(i=0;i<10;i++)
		{
			tasks[i] = new LinkedList<Task>();
		}
	}

	public static void main(String[] argv)// throw IOException
	{
		(new Schedulatore()).exec(argv);
	}

	public void exec(String[] argv)// throws IOException
	{
		while(true)
		{
			String cmd = null;
			System.out.print("Elenco/Esegui/Task/NuovaPriorita/Rimuovi/Storico/Esci ? > ");
			try
			{
				cmd = stdin.readLine();
			}
			catch(IOException ioe2)
			{
				ioe2.printStackTrace();
				break;
			}
			if(cmd == null || cmd.equals("Esci"))
			{
				break;
			}
			else if(cmd.equals("Elenco"))
			{
				elenco();
			}
			else if(cmd.equals("Esegui"))
			{
				esegui();
			}
			else if(cmd.equals("Task"))
			{
				task();
			}
			else if(cmd.equals("NuovaPriorita"))
			{
				nuovaPriorita();
			}
			else if(cmd.equals("Rimuovi"))
			{
				rimuovi();
			}
			else if(cmd.equals("Storico"))
			{
				storico();
			}
			else
			{
				System.out.println("Comando <" + cmd + "> non ricnonsciuto");
				continue;
			}
		}
	}

	void elenco()
	{
		int i = 0;
		for(i=0;i<10;i++)
		{
			System.out.println(tasks[i]);
		}
	}

	void esegui()
	{
		int p;
		long s;
		try
		{
			System.out.print("Priorita'? > ");
			String pri = stdin.readLine();
			System.out.print("Scadenza? > ");
			String scad = stdin.readLine();
			p = Integer.parseInt(pri);
			s = Long.parseLong(scad);
		}
		catch(NumberFormatException nfe)
		{
			nfe.printStackTrace();
			return;
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return;
		}

		// non controllo la correttezza della priorita'
		List<Task> l = tasks[p];
		ListIterator<Task> li = l.listIterator();
		while(li.hasNext())
		{
			Task t = li.next();
			if(t.scadenza > s)
			{
				break;
			}
			li.remove();
			scaduti.add(t);
			System.out.println(t);
		}
	}

	void task()
	{
		String id;
		int p;
		long s;
		try
		{
			System.out.print("ID ? > ");
			id = stdin.readLine();
			System.out.print("Priorita'? > ");
			String pri = stdin.readLine();
			System.out.print("Scadenza? > ");
			String scad = stdin.readLine();
			p = Integer.parseInt(pri);
			s = Long.parseLong(scad);
		}
		catch(NumberFormatException nfe)
		{
			nfe.printStackTrace();
			return;
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return;
		}
		Task t = new Task(id, p, s);
		tasks[p].add(t);
		Collections.sort(tasks[p]);
	}

	void nuovaPriorita()
	{
		String id;
		int p;
		try
		{
			System.out.print("ID? > ");
			id = stdin.readLine();
			System.out.print("Priorita'? > ");
			p = Integer.parseInt(stdin.readLine());
		}
		catch(NumberFormatException nfe)
		{
			nfe.printStackTrace();
			return;
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return;
		}
		int i = 0;
		for(i=0;i<10;i++)
		{
			List<Task> l = tasks[i];
			ListIterator<Task> li = l.listIterator();
			while(li.hasNext())
			{
				Task t = li.next();
				if(t.id.equals(id))
				{
					t.priorita = p;
					li.remove();
					tasks[p].add(t);
					Collections.sort(tasks[p]);
					System.out.println(t);
					i = 10;
					break;
				}
			}
		}
	}

	void rimuovi()
	{
		String id;
		try
		{
			System.out.print("ID? > ");
			id = stdin.readLine();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return;
		}
		int i = 0;
		for(i=0;i<10;i++)
		{
			List<Task> l = tasks[i];
			ListIterator<Task> li = l.listIterator();
			while(li.hasNext())
			{
				Task t = li.next();
				if(t.id.equals(id))
				{
					System.out.println(t);
					li.remove();
					i = 10;
					break;
				}
			}
		}
	}

	void storico()
	{
		Collections.sort(scaduti);
		System.out.println(scaduti);
	}
}
