import java.util.*;

public class ChiaveCoordinate
implements Comparable<ChiaveCoordinate>
{
	int x, y;

	public ChiaveCoordinate(int theX, int theY)
	{
		x = theX;
		y = theY;
	}

	public boolean equals(Object o)
	{
		if(! (o instanceof ChiaveCoordinate))
		{
			return false;
		}
		ChiaveCoordinate cc = (ChiaveCoordinate)o;

		return (x == cc.x) && (y == cc.y);
	}

	public int hashCode()
	{
		return toString().hashCode();
	}

	public int compareTo(ChiaveCoordinate cc)
	{
		int retval = x - cc.x;
		if(retval == 0)
		{
			return y - cc.y;
		}
		return retval;
	}

	public String toString()
	{
		return "<" + x + ";" + y + ">";
	}

	public static void main(String[] argv)
	{
		(new ChiaveCoordinate(0,0)).exec(argv);
	}

	public void exec(String[] argv)
	{
		Map<ChiaveCoordinate, String>coordX = new TreeMap<ChiaveCoordinate, String>();
		Map<ChiaveCoordinate, String>coordY = new TreeMap<ChiaveCoordinate, String>(new ComparaPerY());
		int k = Integer.parseInt(argv[0]);
		int i,j;
		for(i=0;i<k;i++)
		{
			for(j=0;j<k;j++)
			{
				ChiaveCoordinate cc = new ChiaveCoordinate(i,j);
				System.out.println(cc + " == " + cc.hashCode());
				coordX.put(cc, cc.toString());
				coordY.put(cc, cc.toString());
			}
		}

		System.out.println(coordX);
		System.out.println(coordX.keySet());
		System.out.println(coordX.values());
		System.out.println(coordX.entrySet());

		System.out.println(coordY);
		System.out.println(coordY.keySet());
		System.out.println(coordY.values());
		System.out.println(coordY.entrySet());


		for(i=0;i<k;i++)
		{
			for(j=0;j<k;j++)
			{
				ChiaveCoordinate cc = new ChiaveCoordinate(i,j);
				System.out.println(cc + " == " + cc.hashCode());
				System.out.println(coordX.get(cc));
				System.out.println(coordY.get(cc));
			}
		}
	}

	class ComparaPerY
	implements java.util.Comparator<ChiaveCoordinate>
	{
		public boolean equals(Object o)
		{
			return (o instanceof ComparaPerY);
		}

		public int compare(ChiaveCoordinate c1, ChiaveCoordinate c2)
		{
			int retval = c1.y - c2.y;
			if(retval == 0)
			{
				return c1.x - c2.x;
			}
				return retval;
						}
					}
}
