public class StackInt
{
	private int[] elementi;
	private int size;

	/**
	* Costruttore di StackInt, il parametro rappresenta il numero massimo di elementi contenibili.
	*/
	public StackInt(int size)
	{
		elementi = new int[size];
		size = 0;
	}

	/**
	* Costruttore di default di StackInt, il default contiene al massimo 5 elementi.
	*/
	public StackInt()
	{
		this(5);
	}

	/**
	* Metodo di controllo della condizione di stack vuoto, true se vuoto.
	*/
	public boolean empty()
	{
		return (size == 0);
	}

	/**
	* Lettura non distruttiva dell'elemento in cima allo stack.
	* Nel caso in cui lo stack sia vuoto, viene generata una ArrayIndexOutOfBoundException.
	*/
	public int peek()
	{
		return elementi[size-1];
	}

	/**
	* Lettura distruttiva dell'elemento in cima allo stack.
	* Nel caso in cui lo stack sia vuoto, viene generata una ArrayIndexOutOfBoundException.
	*/
	public int pop()
	{
		return elementi[--size];
		/*
		int retval = elementi[size-1];
		size = size-1;
		return retval;
		*/
	}

	/**
	* Inserimento dell'elemento passato in cima allo stack.
	* Nel caso in cui lo stack sia pieno (size == elementi.length), viene generata una ArrayIndexOutOfBoundException.
	*/
	public int push(int elem)
	{
		elementi[size++] = elem;
		return size;
		/*
		elementi[size] = elem;
		size = size + 1;
		return size;
		*/
	}

	/**
	* Cerca un elemento nello stack. Ritorna la posizione della prima occorrenza dell'elemento cercato a partire dalla cima dello stack. Ritorna -1 se l'elemento non e' presente nello stack.
	*/
	public int search(int elem)
	{
		/*
		boolean trovato = false;
		int retval = 0;
		for(retval=0;retval<size;retval++)
		{
			if(elementi[retval] == elem)
			{
				trovato = true;
				break;
			}
		}
		if(trovato)
		{
			return retval;
		}
		else
		{
			return -1;
		}
		*/
		/*
		int retval = 0;
		for(retval=0;retval<size;retval++)
		{
			if(elementi[retval] == elem)
			{
				return retval;
			}
		}
		return -1;
		*/

		int retval = 0;
		for(retval=size-1;retval>=0;retval--)
		{
			if(elementi[retval] == elem)
			{
				break;
			}
		}
		return retval;
	}

	/**
	* Fornisce il numero di elementi presenti nello stack.
	*/
	public int size()
	{
		return size;
	}
}
