package figure;

import java.io.*;

/**
* Classe che legge da un file una sequenza di oggetti Disegnabile e li visualizza sulla console.
*/
public class Disegnatore2
{
	//Queue lista = new poligoni.CircularObjectQueue(20);
	Queue<Disegnabile> lista = new LinkedQueue<Disegnabile>();

	public static void main(String[] argv)
	{
		File f = new File(argv[0]);
		Disegnatore2 d = new Disegnatore2();
		// inserisco un oggetto non disegnabile per far vedere che il compilatore non se ne puo' accorgere
		//d.lista.offer(argv[0]);
		try
		{
			d.caricaFigureDaFile(f);
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		System.out.println(d.lista);
		d.visualizzaFigure();
	}

	public int caricaFigureDaFile(File f) throws IOException
	{
		BufferedReader br = null;
		br = new BufferedReader(new FileReader(f));

		String tipo = null;
		while( (tipo = br.readLine()) != null)
		{
			Popolabile p = null;
			if(tipo.equals("Triangolo"))
			{
				p = new Triangolo();
			}
			else if(tipo.equals("Quadrato"))
			{
				p = new Quadrato();
			}
			else if(tipo.equals("Rettangolo"))
			{
				p = new Rettangolo();
			}
			else if(tipo.equals("TortaDiMele"))
			{
				p = new TortaDiMele();
			}
			else
			{
				System.err.println("Tipo <" + tipo + "> non noto al sistema");
				continue;
			}

			if(p.popola(br))
			{
				lista.add((Disegnabile)p);
			}
		}
		return lista.size();
	}

	public int visualizzaFigure()
	{
		int retval = 0;
		int i = 0;
		for(i=0;i<lista.size();i++)
		{
			//Disegnabile disegnabile = (Disegnabile)lista.poll();
			Disegnabile tmp = lista.poll();
			tmp.disegnati();
			lista.offer(tmp);
		}
		return retval;
	}
}
