package figure;

public class LinkedQueue<E>
implements Queue<E>
{
	NodoDoppio<E> head, tail;
	int numElem;

	public LinkedQueue()
	{
		numElem = 0;
		head = tail = null;
	}

	public boolean add(E e)
	{
		NodoDoppio<E> tmp = new NodoDoppio<E>(e);
		if(numElem == 0)
		{
			head = tail = tmp;
		}
		else
		{
			tail.next = tmp;
			tmp.prev = tail;
			tail = tail.next;
		}
		numElem++;
		return true;
	}

	public boolean offer(E e)
	{
		return add(e);
	}

	public boolean isFull()
	{
		return false;
	}

	public boolean isEmpty()
	{
		return numElem == 0;
	}

	public E remove()
	{
		//Lunghezza 0
		if(isEmpty())
		{
			throw new java.util.NoSuchElementException("Coda vuota");
		}
		E retval;
		retval = head.contenuto;
		//Lunghezza 1
		if(numElem == 1)
		{
			head = tail = null;
			numElem--;
			return retval;
		}
		//Lunghezza >= 2
		head = head.next;
		head.prev = null;
		numElem--;
		return retval;
	}

	/**
	* Metodo che estrae l'elemento di testa. In caso di coda vuota ritorna null. ATTENZIONE, l'implementazione corrente non impedisce l'inserimento di un elemento null.
	*/
	public E poll()
	{
		if(isEmpty())
		{
			return null;
		}
		return remove();
	}

	public E element()
	{
		if(isEmpty())
		{
			throw new java.util.NoSuchElementException("Coda vuota");
		}
		return head.contenuto;
	}

	public E peek()
	{
		if(isEmpty())
		{
			return null;
		}
		return head.contenuto;
	}

	public int size()
	{
		return numElem;
	}

	class NodoDoppio<E>
	{
		E contenuto;
		NodoDoppio<E> next, prev;

		NodoDoppio(E cont)
		{
			contenuto = cont;
			next=prev=null;
		}

		NodoDoppio()
		{
			this(null);
		}
	}
}
