package figure;

import java.io.*;
import poligoni.Lato;

/**
* Classe che rappresenta un quadrato popolabile e disegnabile
*/
public class Quadrato
implements Popolabile, Disegnabile
{
	Lato l;

	public boolean popola(BufferedReader br)
	{
		try
		{
			String lun = br.readLine();
			if(lun == null)
			{
				System.err.println("Quadrato: manca lunghezza lato");
				return false;
			}
			l = new Lato(Double.parseDouble(lun));
		}
		catch(NumberFormatException nfe)
		{
			System.err.println("Quadrato: lato non numerico");
			nfe.printStackTrace();
			return false;
		}
		catch(IOException ioe)
		{
			System.err.println("Quadrato: errore in lettura stream");
			ioe.printStackTrace();
			return false;
		}
		return true;
	}

	public boolean disegnati()
	{
		System.out.println(toString());
		return true;
	}

	public String toString()
	{
		return "Quadrato di lato " + l.getLunghezza();
	}
}
