package figure;

import java.io.*;
import poligoni.Lato;

/**
* Classe che rappresenta un rettangolo popolabile e disegnabile
*/
public class Rettangolo
implements Popolabile, Disegnabile
{
	Lato b,h;

	public boolean popola(BufferedReader br)
	{
		try
		{
			String l1 = br.readLine();
			String l2 = br.readLine();
			if(l1 == null || l2 == null)
			{
				System.err.println("Rettangolo: record incompleto");
				return false;
			}
			b = new Lato(Double.parseDouble(l1));
			h = new Lato(Double.parseDouble(l2));
		}
		catch(NumberFormatException nfe)
		{
			System.err.println("Rettangolo: lato non numerico");
			nfe.printStackTrace();
			return false;
		}
		catch(IOException ioe)
		{
			System.err.println("Rettangolo: errore in lettura stream");
			ioe.printStackTrace();
			return false;
		}
		return true;
	}

	public boolean disegnati()
	{
		System.out.println(toString());
		return true;
	}

	public String toString()
	{
		return "Rettangolo di base " + b.getLunghezza() + " e altezza " + h.getLunghezza();
	}
}
