package figure;

import java.io.*;
import poligoni.Lato;

/**
* Classe popolabile che rappresenta un triangolo
*/
public class Triangolo
implements Popolabile, Disegnabile, Comparable, Perimetrabile
{
	Lato[] lati = new Lato[3];

	public boolean popola(BufferedReader br)
	{
		String l1, l2, l3;
		try
		{
			l1 = br.readLine();
			l2 = br.readLine();
			l3 = br.readLine();
			if(l1 == null || l2 == null || l3 == null)
			{
				System.err.println("Triangolo: record incompleto");
				return false;
			}

			double d1, d2, d3;
			d1 = Double.parseDouble(l1);
			d2 = Double.parseDouble(l2);
			d3 = Double.parseDouble(l3);

			/* Questa parte non genera eccezioni */
			lati[0] = new Lato(d1);
			lati[1] = new Lato(d2);
			lati[2] = new Lato(d3);
		}
		catch(NumberFormatException nfe)
		{
			System.err.println("Triangolo: lato non numerico");
			nfe.printStackTrace();
			return false;
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return false;
		}
		return true;
	}

	public double perimetro()
	{
		return lati[0].getLunghezza() + lati[1].getLunghezza() + lati[2].getLunghezza();
	}

	public int compareTo(Object o)
	{
		Perimetrabile t = (Perimetrabile)o;
		return (int)(perimetro()-t.perimetro());
	}

	public boolean disegnati()
	{
		System.out.println(toString());
		return true;
	}

	public String toString()
	{
		String retval = "Triangolo: " + lati[0].getLunghezza() + ", " + lati[1].getLunghezza() + ", " + lati[2].getLunghezza();
		return retval;
	}
}
