package map;

import java.util.*;
import java.io.*;
import figure.Popolabile;

public class Biblioteca
{
	Map<String, List<Libro>> autori;
	Map<String, Libro> isbn;
	Map<Integer, List<Libro>> anni;
	List<Libro> lista;
	boolean ordinata = false;
	BufferedReader stdin;

	public static void main(String[] argv) throws IOException
	{
		(new Biblioteca()).exec(argv);
	}

	public Biblioteca()
	{
		autori = new HashMap<String, List<Libro>>();
		anni = new HashMap<Integer, List<Libro>>();
		isbn = new HashMap<String, Libro>();
		lista = new ArrayList<Libro>();
		stdin = new BufferedReader(new InputStreamReader(System.in));
	}

	public void exec(String[] argv) throws IOException
	{
		while(true)
		{
			String cmd = null;
			System.out.print("Leggi/Stampa/Autore/Anno/Isbn/Esci ? > ");
			try
			{
				cmd = stdin.readLine();
			}
			catch(IOException ioe2)
			{
				ioe2.printStackTrace();
				break;
			}
			if(cmd == null || cmd.equals("Esci"))
			{
				break;
			}
			else if(cmd.equals("Leggi"))
			{
				leggi();
			}
			else if(cmd.equals("Stampa"))
			{
				stampa();
			}
			else if(cmd.equals("Autore"))
			{
				autore();
			}
			else if(cmd.equals("Anno"))
			{
				anno();
			}
			else if(cmd.equals("Isbn"))
			{
				isbn();
			}
			else
			{
				System.out.println("Comando <" + cmd + "> non ricnonsciuto");
				continue;
			}
		}
	}

	public void stampa()
	{
		/*
		List<Libro> l = new ArrayList<Libro>();
		l.addAll(isbn.values());

		Collections.sort(l, new ComparaLibro());
		System.out.println(l);
		*/

		if(!ordinata)
		{
			ordinata = true;
			Collections.sort(lista, new ComparaLibri());
		}
		System.out.println(lista);
	}

	public void anno()
	{
		System.out.print("Anno? > ");
		Integer anno = null;
		try
		{
			String linea = stdin.readLine();
			anno = new Integer(linea);
		}
		catch(NumberFormatException nfe)
		{
			nfe.printStackTrace();
			return;
		}
		catch(IOException ioe5)
		{
			ioe5.printStackTrace();
			return;
		}
		List<Libro> l = anni.get(anno);
		System.out.println(l);
	}

	public void autore()
	{
		System.out.print("Autore? > ");
		String autore = null;
		try
		{
			autore = stdin.readLine();
		}
		catch(IOException ioe6)
		{
			ioe6.printStackTrace();
			return;
		}
		List<Libro> l = autori.get(autore);
		System.out.println(l);
	}

	public void isbn()
	{
		System.out.print("Isbn? > ");
		String chiave = null;
		try
		{
			chiave = stdin.readLine();
		}
		catch(IOException ioe7)
		{
			ioe7.printStackTrace();
			return;
		}
		System.out.println(isbn.get(chiave));
	}

	public void leggi()
	{
		System.out.print("Nome file? > ");
		String nomeFile = null;
		BufferedReader br = null;
		try
		{
			nomeFile = stdin.readLine();
			br = new BufferedReader(new FileReader(new File(nomeFile)));

			String tipo = null;
			while( (tipo = br.readLine()) != null)
			{
				Popolabile p = null;
				if(tipo.equals("Libro"))
				{
					System.out.println("Nuovo Libro");
					p = new Libro();
				}
				else
				{
					System.err.println("Oggetto <" + tipo + "> non noto");
					continue;
				}
				if(p.popola(br))
				{
					if(p instanceof Libro)
					{
						Libro b = (Libro)p;
						if(b.validato)
						{
							//inserisco nella Mappa <autori, libri>
							List<Libro> l = autori.get(b.autore);
							if(l == null)
							{
								l = new LinkedList<Libro>();
								autori.put(b.autore, l);
							}
							l.add(b);

							//inserisco nella Mappa <anni, libri>
							//Uso il simbolo l ma vi assegno un nuovo valore
							l = anni.get(new Integer(b.annoPubblicazione));
							if(l == null)
							{
								l = new LinkedList<Libro>();
								anni.put(new Integer(b.annoPubblicazione), l);
							}
							l.add(b);

							//inserisco nella Mappa <isbn, libro>
							if(isbn.containsKey(b.isbn))
							{
								// ho gia' in biblioteca un libro con quel valore di isbn:
								// che faccio?
								System.out.println("WARNING: isbn <" + b.isbn + "> duplicato");
							}
							isbn.put(b.isbn, b);


							//Aggiungo alla lista per stampa globale ordinata
							lista.add(b);
							ordinata = false;
						}
						else
						{
							System.out.println("Libro non validato");
						}
					}
					else
					{
						System.out.println("Se non e' un Libro non so che fare");
					}
				}
				else
				{
					System.out.println("popola fallito");
				}
			}
		}
		catch(IOException ioe3)
		{
			ioe3.printStackTrace();
			return;
		}
		try
		{
			br.close();
		}
		catch(IOException ioe4)
		{
			ioe4.printStackTrace();
		}
	}
}
