package map;

import java.io.*;

public class Libro
implements figure.Popolabile
{
	String autore;
	String titolo;
	int annoPubblicazione;
	String isbn;

	boolean validato = false;

	Validatore v;

	public Libro()
	{
		this(null);
	}

	public Libro(Validatore validatore)
	{
		if(validatore == null)
		{
			v = Validatore.getDefaultValidatore();
		}
		else
		{
			v = validatore;
		}
		autore = titolo = isbn = null;
		annoPubblicazione = 0;
	}

	public boolean popola(BufferedReader in)
	{
		String linea;
		try
		{
			linea = in.readLine();
			if(linea == null)
			{
				return false;
			}
			//se ci sono dei test di validazione sull'autore, si fanno qui
			linea = linea.trim();
			validato = v.valida(linea);
			autore = linea;

			linea = in.readLine();
			if(linea == null)
			{
				return false;
			}
			titolo = linea.trim();

			linea = in.readLine();
			if(linea == null)
			{
				return false;
			}
			try
			{
				annoPubblicazione = Integer.parseInt(linea.trim());
			}
			catch(NumberFormatException nfe)
			{
				nfe.printStackTrace();
				return false;
			}

			linea = in.readLine();
			if(linea == null)
			{
				return false;
			}
			linea = linea.trim();
			if(v.validaIsbn(linea))
			{
				isbn = linea;
			}
			else
			{
				System.err.println("ISBN <" + linea + "> non valido");
				return false;
			}
			return true;
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return false;
		}
	}
}
